<?php
namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;

class ExportConfigSobProdERec{
    
    public function __construct(EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }
    
    public function find($conditions){
        return $this->entityManager->getConnection()->fetchAll(self::QUERY_FIND, $conditions);
    }
    
    public function exportProduto($CDFILIAL, $NRCONFTELA, $rows, $DTINIVIGENCIAORIG){ 
        $this->entityManager->getConnection()->beginTransaction(); 
        try{ 
            foreach ($rows as $row) { 
                $conditions[':CDFILIALDEST'] = $row['CDFILIAL']; 
                $conditions[':NRCONFTELADEST'] = $row['NRCONFTELA']; 
                $conditions[':CDFILIALORIG'] = $CDFILIAL; 
                $conditions[':NRCONFTELAORIG'] =  $NRCONFTELA; 
                $conditions[':DTINIVIGENCIAORIG'] =  $DTINIVIGENCIAORIG; 
                $conditions[':DTINIVIGENCIADEST'] =  $row['DTINIVIGENCIA'];
                $this->deleteRowsProduto($row); 
                $this->entityManager->getConnection()->executeQuery(self::INSERT_PRODUTOS, $conditions); 
            } 

            $this->entityManager->getConnection()->commit(); 
            return true; 
        }catch(Exception $e){ 
            $this->entityManager->getConnection()->rollBack(); 
            return false; 
        } 
    } 
     
    public function exportRecebimento($CDFILIAL, $NRCONFTELA, $rows, $DTINIVIGENCIAORIG){ 
        $this->entityManager->getConnection()->beginTransaction(); 
        try{ 
            foreach ($rows as $row) { 
                $conditions[':CDFILIALDEST'] = $row['CDFILIAL']; 
                $conditions[':NRCONFTELADEST'] = $row['NRCONFTELA']; 
                $conditions[':CDFILIALORIG'] = $CDFILIAL; 
                $conditions[':NRCONFTELAORIG'] =  $NRCONFTELA; 
                $conditions[':DTINIVIGENCIAORIG'] =  $DTINIVIGENCIAORIG; 
                $conditions[':DTINIVIGENCIADEST'] =  $row['DTINIVIGENCIA']; 
                $this->deleteRowsRecebimento($row); 
                $this->entityManager->getConnection()->executeQuery(self::INSERT_RECEBIMENTO, $conditions); 
            } 
            $this->entityManager->getConnection()->commit(); 
            return true; 
        }catch(Exception $e){ 
            $this->entityManager->getConnection()->rollBack(); 
            return false; 
        } 
    } 

    private function deleteRowsProduto ($row){
        $conditions[':CDFILIAL'] = $row['CDFILIAL'];
        $conditions[':NRCONFTELA'] = $row['NRCONFTELA'];
        $this->entityManager->getConnection()->executeQuery(self::QUERY_DELETE_PRODUTO, $conditions);
      
    }
    
    private function deleteRowsRecebimento($row){
        $conditions[':CDFILIAL'] = $row['CDFILIAL'];
        $conditions[':NRCONFTELA'] = $row['NRCONFTELA'];
        $this->entityManager->getConnection()->executeQuery(self::QUERY_DELETE_RECEBIMENTO, $conditions);
      
        
    }
    
    const INSERT_PRODUTOS = "
        INSERT INTO ITMENUCONFTE (CDFILIAL, NRCONFTELA, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX, NRBUTTONAUX,
                                  NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK, DSMESSAGEBUT, DSIMAGEMBUT, 
                                  NRFONTETEXT, IDATIVO, DSENDEIMG, DTINIVIGENCIA)
        SELECT :CDFILIALDEST, :NRCONFTELADEST, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX, NRBUTTONAUX,
               NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK, DSMESSAGEBUT, DSIMAGEMBUT, NRFONTETEXT, 
               IDATIVO, DSENDEIMG, :DTINIVIGENCIADEST
          FROM ITMENUCONFTE
         WHERE (CDFILIAL   = :CDFILIALORIG  ) 
           AND (NRCONFTELA = :NRCONFTELAORIG) 
           AND (DTINIVIGENCIA = :DTINIVIGENCIAORIG) 
           AND (IDTPBUTTON IN ('2','7','8','1','9','A'))
    ";
    
    const INSERT_RECEBIMENTO = "
        INSERT INTO ITMENUCONFTE (CDFILIAL, NRCONFTELA, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX, NRBUTTONAUX,
                                  NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK, DSMESSAGEBUT, DSIMAGEMBUT, 
                                  NRFONTETEXT, IDATIVO, DSENDEIMG, DTINIVIGENCIA)
        SELECT :CDFILIALDEST, :NRCONFTELADEST, IDTPBUTTON, NRBUTTON, NRPGCONFTELA, IDTPBUTONAUX, NRBUTTONAUX,
               NRPGCONFTAUX, CDIDENTBUTON, DSBUTTON, NRCOLORTEXT, NRCOLORBACK, DSMESSAGEBUT, DSIMAGEMBUT, 
               NRFONTETEXT, IDATIVO, DSENDEIMG, :DTINIVIGENCIADEST
          FROM ITMENUCONFTE
         WHERE (CDFILIAL   = :CDFILIALORIG  ) 
           AND (NRCONFTELA = :NRCONFTELAORIG) 
           AND (DTINIVIGENCIA = :DTINIVIGENCIAORIG) 
           AND (IDTPBUTTON IN ('6','5','G','H'))
    ";
    
    const QUERY_DELETE_RECEBIMENTO = "
        DELETE
            FROM ITMENUCONFTE  
            WHERE CDFILIAL = :CDFILIAL
            AND NRCONFTELA = :NRCONFTELA
            AND IDTPBUTTON IN('6','5','G','H')
    ";
    
    const QUERY_DELETE_PRODUTO = "
        DELETE
            FROM ITMENUCONFTE  
            WHERE CDFILIAL = :CDFILIAL
            AND NRCONFTELA = :NRCONFTELA
            AND IDTPBUTTON IN('2','7','8','1','9','A')
    ";
    
    const  QUERY_FIND = "
    SELECT F.CDFILIAL, F.NMFILIAL, 
    C.CDFILIAL||' - '||F.NMFILIAL AS NMFILIAL, 
    L.CDLOJA, L.NMLOJA, L.CDLOJA ||' - '|| L.NMLOJA AS NMLOJA,
    C.NRCONFTELA, 
    C.NRORG, C.NMCONFTELA, 
    C.NRCONFTELA ||' - '|| C.NMCONFTELA AS NMCONFIG 
    FROM LOJA L, FILIAL F, CONFTELA C 
    WHERE L.CDLOJA  = C.CDLOJA  AND L.CDFILIAL = C.CDFILIAL 
    AND L.CDFILIAL = F.CDFILIAL AND NOT EXISTS
        (SELECT 1 FROM CONFTELA WHERE CDFILIAL   = C.CDFILIAL AND NRCONFTELA = C.NRCONFTELA 
            AND CDFILIAL   = :CDFILIAL AND NRCONFTELA = :NRCONFTELA) 
    ORDER BY C.CDFILIAL, C.CDLOJA, C.NRCONFTELA
    ";
}