<?php

namespace Teknisa\MAN\Services;

class File {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
		$this->entityManager = $entityManager;
	}

	public function getFiles($CDARQUIVO, $NMARQUIVO, $ARQUIVO, $TPARQUIVO){
        $CDARQUIVO = empty($CDARQUIVO) ? '%%' : '%'.$CDARQUIVO.'%';
        $NMARQUIVO = empty($NMARQUIVO) ? '%%' : '%'.$NMARQUIVO.'%';
        $ARQUIVO   = empty($ARQUIVO  ) ? '%%' : '%'.$ARQUIVO  .'%';
        $TPARQUIVO = empty($TPARQUIVO) ? '%%' : '%'.$TPARQUIVO.'%';
        $params = array(
            ':CDARQUIVO' => $CDARQUIVO,
            ':NMARQUIVO' => $NMARQUIVO,
            ':ARQUIVO'   => $ARQUIVO,
            ':TPARQUIVO' => $TPARQUIVO
        );
		return $this->entityManager->getConnection()->fetchAll(self::GET_FILES, $params);
	}

	public function saveFile($CDARQUIVO, $NMARQUIVO, $ARQUIVO, $TPARQUIVO){
        $params = array(
            ':CDARQUIVO' => $CDARQUIVO,
            ':NMARQUIVO' => $NMARQUIVO,
            ':ARQUIVO'   => $ARQUIVO,
            ':TPARQUIVO' => $TPARQUIVO
        );          
        return $this->entityManager->getConnection()->executeQuery(self::SAVE_FILE, $params);
    }
    public function deleteFile($CDARQUIVO){
        $params = array(
            ':CDARQUIVO' => $CDARQUIVO
        );          
        return $this->entityManager->getConnection()->executeQuery(self::DELETE_FILE, $params);
    }

    const SAVE_FILE = "
        INSERT INTO ARQUIVOS
            (CDARQUIVO, NMARQUIVO, ARQUIVO, TPARQUIVO)
        VALUES
            (:CDARQUIVO, :NMARQUIVO, :ARQUIVO, :TPARQUIVO)
    ";

    const DELETE_FILE = "
        DELETE FROM ARQUIVOS WHERE CDARQUIVO = :CDARQUIVO
    ";

    const GET_FILES = "
        SELECT CDARQUIVO, NMARQUIVO, ARQUIVO, TPARQUIVO 
            FROM ARQUIVOS
            WHERE UPPER (CDARQUIVO) LIKE UPPER (:CDARQUIVO)
              AND UPPER (NMARQUIVO) LIKE UPPER (:NMARQUIVO)
              AND UPPER (ARQUIVO)   LIKE UPPER (:ARQUIVO)
              AND UPPER (TPARQUIVO) LIKE UPPER (:TPARQUIVO)
    ";

}